﻿<?php
// 
// WebSite: igorkov.org
// Author: igorkov
// Year: 2015
//

// ---------------------------------- CONFIG -----------------------------------
// Сколько читаем с конца файла:
$lastdata = 512;
// Последняя запись:
$delay = 900; // 15 минут, разумно выполнять проверку каждые 10 минут.
// Файл лога:
$path = "/path/of/file/";
$logfile = $path."online.csv";
// -------------------------------- CONFIG END ---------------------------------

// Прореживание показаний:
if (isset($argv[2]))
{
	$delay = $argv[2];
}
else if (isset($_GET['delay']))
{
	$delay = $_GET['delay'];
}

// Последняя запись в главном логе:
$data = find_last($logfile, $lastdata);
$timelast = $data[0];
$errorlast = $data[2];

// Открываем лог на запись:
$f = fopen($logfile, 'a');

if (isset($argv[1]))
{
	$filename = preg_replace('/[^a-zA-Z0-9-]/', '', $argv[1]);
	$file = $path.$filename.".csv";
	//fwrite($f, time().";".$filename.";".$delay.";OK"."\r\n");
}
else if (isset($_GET['file']))
{
	$filename = preg_replace('/[^a-zA-Z0-9-]/', '', $_GET['file']);
	$file = $path.$filename.".csv";
	//fwrite($f, time().";".$filename.";".$delay.";OK"."\r\n");
}
else
{
	fwrite($f, time().";".$filename.";0;NO FILE"."\r\n");
	fclose($f);
	echo "NO FILE";
	exit(0);
}

// Проверяем время
if ($timelast == 0)
{
	fwrite($f, time().";".$filename.";0;FIND_LAST ERROR (1)"."\r\n");
	fclose($f);
	echo "FIND LAST ERROR";
	exit(0);
}
else if ((time()-$timelast) > $delay)
{
	$min = floor((time()-$timelast)/60);
	// Информация в лог:
	fwrite($f, time().";".$filename.";0;SERVER DOWN: ".$min." min"."\r\n");
	// Вывод на экран:
	echo "SERVER DOWN: ".$min." min";
	// Информация по почте:
	mail_utf8("<ADMIN-E-MAIL>",
	          "Server down!",
			  "WARNING: перерыв в работе сервера ".$min." мин.!",
			  "Robot by igorkov.org",
			  "xxx@igorkov.org");
	// Отправка SMS-сообщения с предупреждением:
	file_get_contents("http://sms.ru/sms/send?api_id=<TOKEN>&to=<TELEPHONE>&from=ROBOT@IGORKOV&text=SERVER DOWN: ".$min." min!");
	// 
	fclose($f);
	exit(0);
}

$data = find_last($file, $lastdata);
$timelast = $data[0];
if ($timelast == 0)
{
	fwrite($f, time().";".$filename.";0;FIND_LAST ERROR (2)"."\r\n");
	fclose($f);
	
	echo "FIND LAST ERROR";
	exit(0);
}
else if ((time()-$timelast) > $delay)
{
	// Информация в лог:
	fwrite($f, time().";".$filename.";".$timelast.";FREEZE"."\r\n");
	// Вывод на экран:
	echo "WARNING: LOGGING FREEZE";

	if ($errorlast != $timelast)
	{
		// Информация по почте:
		mail_utf8("<ADMIN-E-MAIL>", 
				  "Logging freeze!",
				  "WARNING: ведение лога ".$file." остановлено! Возможно имеются проблемы с клиентом!",
				  "Robot by igorkov.org",
				  "xxx@igorkov.org");
		
		// Отправка SMS-сообщения с предупреждением:
		file_get_contents("http://sms.ru/sms/send?api_id=<TOKEN>&to=<TELEPHONE>&from=ROBOT@IGORKOV&text=LOG ".$filename." FREEZE!");
	}
}
else
{
	fwrite($f, time().";".$filename.";".$delay.";OK"."\r\n");
	echo "OK";
}
fclose($f);

////////////////////////////
// Функции:
////////////////////////////

function find_last($file, $lastdata)
{
	$datalast[0] = 0;
	$timeold = 0;
	if (($handle = fopen($file, "r")) !== FALSE)
	{
		if ($lastdata){
			// Только последние 100кб
			fseek($handle, 0, SEEK_END);
			$offset = ftell($handle);
			if ($offset>$lastdata)
			{
				fseek($handle, $offset-$lastdata);
				while (1)
				{
					$res = fread($handle, 1);
					if ($res == "\r")
						break;
					if ($res == EOF)
						break;
				}
			}
			else
			{
				fseek($handle, 0, SEEK_SET);
			}
		}
		while (($data = fgetcsv($handle, 10000, ";")) !== FALSE)
		{
			if ($data[0] > $timeold)
			{
				$datalast = $data;
				$timeold = $data[0];
			}
		}
		fclose($handle);
		return $datalast;
	}else{
		return $datalast;
	}
}

function mail_utf8($to, $subject, $message, $name, $email)
{
	$subject  = "=?UTF-8?B?".base64_encode($subject)."?=";
	$headers  = "MIME-Version: 1.0\r\n"; 
	$headers .= "Content-type: text/plain; charset=utf-8\r\n";
	$headers .= "From: =?UTF-8?B?".base64_encode($name)."?= <".$email.">\r\n";
	return mail($to, $subject, $message, $headers);
}


?>
